<template>
  <div class="container">
    <!-- {{ $store.getters.nickName }} -->
    <div class="table-container">
      <el-table
        ref="productTable"
        :data="list"
        style="width: 100%"
        @selection-change="handleSelectionChange"
        v-loading="listLoading"
        border
        @sort-change="changeTableSort"
      >
        <el-table-column
          type="selection"
          width="60"
          align="center"
        ></el-table-column>
        <el-table-column label="姓名" align="center">
          <template slot-scope="scope">
            <div
              class="handleStuDetail"
              @click="handleStuDetail(scope.row.userId)"
            >
              {{ scope.row.name }}
            </div>
          </template>
        </el-table-column>

        <el-table-column label="所在学校" align="center">
          <template slot-scope="scope">{{ scope.row.school }}</template>
        </el-table-column>
        <el-table-column label="年级" align="center">
          <template slot-scope="scope">{{
            //   scope.row.grade
            scope.row.grade == 1
              ? "大一"
              : scope.row.grade == 2
              ? "大二"
              : scope.row.grade == 3
              ? "大三"
              : scope.row.grade == 4
              ? "大四"
              : scope.row.grade == 5
              ? "大五"
              : ""
          }}</template>
        </el-table-column>
        <el-table-column label="报课数量" align="center">
          <template slot-scope="scope">{{ scope.row.courseNum }}</template>
        </el-table-column>
        <el-table-column label="授课形式" align="center">
          <template slot-scope="scope">{{ scope.row.teachWay }}</template>
        </el-table-column>
        <!-- <el-table-column label="最近沟通记录" align="center">
          <template slot-scope="scope">{{ scope.row.context }}</template>
        </el-table-column> -->
        <!-- <el-table-column
          label="最近沟通时间"
          :sortable="'custom'"
          align="center"
          prop="addTime"
        >
          <template slot-scope="scope">{{ scope.row.addTime }}</template>
        </el-table-column> -->
        <el-table-column
          label="缴费时间"
          :sortable="'custom'"
          align="center"
          prop="addTime"
        >
          <template slot-scope="scope">{{ scope.row.addTime }}</template>
        </el-table-column>
        <el-table-column label="选课数量" align="center">
          <template slot-scope="scope">{{
            scope.row.chooseCourseNum
          }}</template>
        </el-table-column>
        <el-table-column label="审课大学" align="center">
          <template slot-scope="scope">{{ scope.row.auditSchool }}</template>
        </el-table-column>
        <el-table-column label="分配老师" align="center">
          <template slot-scope="scope">
            <el-select clearable v-model="scope.row.teacherId">
              <el-option
                v-for="item in options"
                :key="item.id"
                :label="item.nickName"
                :value="item.id"
              >
              </el-option>
            </el-select>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center">
          <template slot-scope="scope">
            <el-button
              @click="
                handleUpdateAllocate(scope.row.teacherId, scope.row.userId)
              "
              size="mini"
              >确认</el-button
            >
          </template>
        </el-table-column>
        <!-- <el-table-column
          label="分配时间"
          :sortable="'custom'"
          align="center"
          prop="allocateTime"
        >
          <template slot-scope="scope">{{ scope.row.allocateTime }}</template>
        </el-table-column> -->
      </el-table>
    </div>

    <div class="pagination-container">
      <el-pagination
        background
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        layout="total,sizes,prev, pager, next,jumper"
        :page-size="pageSize"
        :page-sizes="[5, 10, 15]"
        :current-page.sync="pageNum"
        :total="total"
      >
      </el-pagination>
    </div>
  </div>
</template>

<script>
import {
  xfSelectUnBind,
  kfSelectUnBind,
  adminList,
  xfUpdateAllocate,
  kfUpdateAllocate
} from "@/api/cso";
const defaultListQuery = {
  pageNum: 1,
  pageSize: 10
};
export default {
  name: "unBind",
  data() {
    return {
      listQuery: Object.assign({}, defaultListQuery),
      list: null,
      pageSize: null,
      pageNum: null,
      total: null,
      listLoading: true,
      multipleSelection: [],
      formLabelWidth: "120px",
      options: [],
      teacherId: "",
      roles: "",
      nickName: ""
    };
  },
  methods: {
    getData() {
      xfSelectUnBind(this.listQuery).then(res => {
        // console.log(res, "getData");
        this.listLoading = false;

        this.list = res.data.list;
        this.pageNum = res.data.pageNum;
        this.pageSize = res.data.pageSize;
        this.total = res.data.total;
        console.log(this.list, "this.list,xfSelectUnBind");
        this.$store.commit("set_xfSelectUnBind", res.data.total);
        this.$forceUpdate();
      });
    },
    getAdminList() {
      adminList(2).then(res => {
        // console.log(res, "getAdminList");
        this.options = res.data;
      });
    },
    handleUpdateAllocate(teacherId, userId) {
      this.$confirm("是否要确认", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(() => {
        if (teacherId) {
          console.log("学服部主管");
          xfUpdateAllocate({
            teacherId,
            userId
          }).then(res => {
            this.getData();
            this.$forceUpdate();
          });
        } else {
          this.$message({
            type: "error",
            message: "请分配老师",
            duration: 1000
          });
        }
      });
    },
    handleCurrentChange(val) {
      // 翻页
      this.listQuery.pageNum = val;
      this.getData();
    },
    handleSizeChange(val) {
      //切换展示条数
      this.listQuery.pageSize = val;
      this.getData();
    },
    handleStuDetail(id) {
      // 测试用的
      this.$router.push({
        path: "/pms/stuDetail",
        query: {
          id: id
        }
      });
      // console.log(123);
    },
    changeTableSort(column) {
      console.log("prop", column.prop);
      console.log("order", column.order);
      // console.log("column", column);
      if (column.prop == "addTime") {
        this.listQuery.secondSort = null;
        if (column.order == "ascending") {
          this.listQuery.firstSort = 0;
        } else if (column.order == "descending") {
          this.listQuery.firstSort = 1;
        }
      }
      if (column.prop == "allocateTime") {
        this.listQuery.firstSort = null;
        if (column.order == "ascending") {
          this.listQuery.secondSort = 0;
        } else if (column.order == "descending") {
          this.listQuery.secondSort = 1;
        }
      }
      if (column.order == null) {
        this.listQuery.secondSort = this.listQuery.firstSort = null;
      }
      this.getData();
      console.log("changeTableSort");
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    }
  },
  mounted() {
    this.roles = this.$store.state.user.roles;
    this.nickName = this.$store.state.user.nickName;
    this.getData();
    this.getAdminList();
    console.log(this.roles.includes("学服部主管"), "学服部主管");
    console.log(this.roles.includes("客服部主管"), "客服部主管");
  }
};
</script>

<style lang="scss" scoped>
.container {
  padding: 20px;
}
.handleStuDetail {
  cursor: pointer;
}
</style>
